package edu.washington.cs.atomicdebug.examples;

import edu.washington.cs.atomicdebug.AtomicDebug;

/**
 * Test creating a thread within an atomic section. We start a thread that tries
 * to read state that is being updated by the atomic thread.
 * 
 * @author Laura Effinger-Dean
 */
public class SpawnWithinAtomic {
	private static int state;

	public static void main(String[] args) {
		for (int i = 0; i < 100; i++) {
			final Thread t2 = new Thread() {
				public void run() {
					System.out.println("State (should be 3): " + state);
				}
			};
			Thread t1 = new Thread() {
				public void run() {
					try {
						AtomicDebug.enterAtomic();
						state = 2;
						t2.start();
						Thread.sleep(10);
						state = 3;
						AtomicDebug.exitAtomic();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			};
			t1.start();
			try {
				t1.join();
				t2.join();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}